
package de.ivu.elect.presentation.entschaedigung.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.entschaedigung.boundary.AuszahlungExtendedDAO;
import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;
import de.ivu.elect.business.security.UseCasePermission;

@Named(EntschaedigungDeleteAction.COMPONENT_NAME)
public class EntschaedigungDeleteAction extends AbstractEntschaedigungAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungDeleteAction";

  @Inject
  private transient AuszahlungExtendedDAO auszahlungDao;

  public EntschaedigungDeleteAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.ENTSCHAEDIGUNG_DELETE;
  }

  @Override
  public boolean isDisabledInternal(@Nonnull Entschaedigung entschaedigung) {
    return super.isDisabledInternal(entschaedigung) || !isAuszahlungBearbeitbar(entschaedigung);
  }

  private boolean isAuszahlungBearbeitbar(Entschaedigung entschaedigung) {
    return entschaedigung.hasAuszahlung() && auszahlungDao.attach(entschaedigung.getAuszahlung()).isBearbeitbar();
  }

  @Override
  protected boolean isFireChangeEvent() {
    return true;
  }

  @Override
  protected String doIt(Entschaedigung entschaedigung) {
    entschaedigungConversationSelect.setEntity(entschaedigung);

    // Return to current page and display the dialog!
    return null;
  }

  @Override
  public String getDialogName() {
    return "DeleteConfirm";
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.delete";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconDelete();
  }
}
